#include <stdio.h>
#include <iostream.h>
#include <graphics.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "kb.h"

#define VIEW_ANGLE   60
#define SCREEN_RES   320
#define ANGLE_CONST  VIEW_ANGLE / SCREEN_RES

const float MUL_CONST = SCREEN_RES / VIEW_ANGLE;

unsigned char data[128][128];
unsigned char map[32][32];
unsigned char pal[1024];
float tan_table[480];
float cos_table[60];

int dist(int angle, unsigned int xp, unsigned int yp)
{
  long int x = xp, y = yp;
  float x_dist, y_dist;
  long int x_ = xp, y_ = yp;

//**********************************************************

  if (angle >= 0 && angle < 90 * MUL_CONST)
  {
    x = ((x >> 7) + 1) << 7;
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x += 128;
      y = yp - (x - xp) * tan_table[angle];
    }
  }
  else
  if (angle < 180 * MUL_CONST)
  {
    x = (x >> 7) << 7;
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x -= 128;
      y = yp + (x - xp) * tan_table[(int)(180 * MUL_CONST) - angle];
    }
    x += 128;
  }
  else
  if (angle < 270 * MUL_CONST)
  {
    x = (x >> 7) << 7;
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x -= 128;
      y = yp - (x - xp) * tan_table[angle - (int)(180 * MUL_CONST)];
    }
    x += 128;
  }
  else
  if (angle < 360 * MUL_CONST)
  {
    x = ((x >> 7) + 1) << 7;
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x += 128;
      y = yp + (x - xp) * tan_table[(int)(360 * MUL_CONST) - angle];
    }
  }
//  x_dist = sqrt((x - xp) * (x - xp) + (y - yp) * (y - yp));

  x_dist = sqrt(pow(x - xp, 2) + pow(y - yp, 2));

//**********************************************************

/*  if (angle > 0 && angle <= 90 * MUL_CONST)
  {
    y_ = ((y_ >> 7) + 1) << 7;
    while (!map[x_ >> 7][y_ >> 7] && y_ > 0 && y_ < 4096)
    {
      y_ += 128;
      x_ = xp - (y_ - yp) / tan_table[angle];
    }
  }
  else
  if (angle <= 180 * MUL_CONST)
  {
    y_ = (y_ >> 7) << 7;
    while (!map[x_ >> 7][y_ >> 7] && y_ > 0 && y_ < 4096)
    {
      y_ -= 128;
      x_ = xp + (y_ - yp) / tan_table[(int)(180 * MUL_CONST) - angle];
    }
    y_ += 128;
  }
  else
  if (angle < 270 * MUL_CONST)
  {
    y_ = (y_ >> 7) << 7;
    while (!map[x_ >> 7][y_ >> 7] && y_ > 0 && y_ < 4096)
    {
      y_ -= 128;
      x_ = xp - (y_ - yp) / tan_table[angle - (int)(180 * MUL_CONST)];
    }
    y_ += 128;
  }
  else
  if (angle < 360 * MUL_CONST)
  {
    y_ = ((y_ >> 7) + 1) << 7;
    while (!map[x_ >> 7][y_ >> 7] && y_ > 0 && y_ < 4096)
    {
      y_ += 128;
      x_ = xp + (y_ - yp) / tan_table[(int)(360 * MUL_CONST) - angle];
    }
  }
  y_dist = sqrt((x_ - xp) * (x_ - xp) + (y_ - yp) * (y_ - yp));*/

//**********************************************************

//    setcolor(14);
//    line(xp * 14 / 128.0, yp * 14 / 128.0, x * 14 / 128.0, y * 14 / 128.0);
//      delay(5);
//      getch();
    return x_dist;

/*  if (angle < 90 || angle > 270)
  {
    x = ((x >> 7) + 1) << 7;
    y += (x - xp) * tan_table[offs];
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x += 128;
      y = yp + (x - xp) * tan_table[offs];
    }
  }
  else
  if (angle != 90 && angle != 270)
  {
    x = (x >> 7) << 7;
    y += (x - xp) * tan_table[offs];
    while (!map[x >> 7][y >> 7] && y > 0 && y < 4096)
    {
      x -= 128;
      y = yp + (x - xp) * tan_table[offs];
    }
    x += 128;
  }
  x_dist = sqrt((x - xp) * (x - xp) + (y - yp) * (y - yp));
  x_ = x;
  y_ = y;

  x = xp, y = yp;
  if (angle > 0 && angle < 180)
  {
    y = ((y >> 7) + 1) << 7;
    if (tan_table[offs] != 0)
      x += (y - yp) / tan_table[offs];
    while (!map[x >> 7][y >> 7] && x > 0 && x < 4096)
    {
      y += 128;
      if (tan_table[offs] != 0)
        x = xp + (y - yp) / tan_table[offs];
    }
  }
  else
  if (angle != 0 && angle != 180)
  {
    y = (y >> 7) << 7;
    if (tan_table[offs] != 0)
      x += (y - yp) / tan_table[offs];
    while (!map[x >> 7][y >> 7] && x > 0 && x < 4096)
    {
      y -= 128;
      if (tan_table[offs] != 0)
        x = xp + (y - yp) / tan_table[offs];
    }
    y += 128;
  }
  y_dist = sqrt((x - xp) * (x - xp) + (y - yp) * (y - yp));*/

//  if ((x_dist < y_dist) && (x_dist > 0))
//  {
//  }
//  if ((y_dist < x_dist) && (y_dist > 0))
//  {
//    setcolor(14);
//    line(xp * 14 / 128.0, yp * 14 / 128.0, x * 14 / 128.0, y * 14 / 128.0);
//    return y_dist;
//  }
//  return 1;
}

void fill_tables()
{
  for (int angle = 0; angle < 90 * MUL_CONST; angle++)
    tan_table[angle] = tan(angle / MUL_CONST * M_PI / 180);

  for (int i = 0; i < 60; i++)
    cos_table[i] = cos((i - 30) * M_PI / 180);
}

int select_color(int distance)
{
  int color = 15;

  for (int i = 0; i < 15; i++)
    if (distance > i * 256) color--;

  return color + 96;
}

void vert_ret()
{
  asm
  {
      cli
      mov    dx,  03DAh
@1:   in     al,  dx
      test   al,  8
      jz     @1
@2:   in     al,  dx
      test   al,  8
      jnz    @2
      sti
  }
}

void set_mode(unsigned int mode)
{
  asm
  {
      mov    ax,  mode
      int    10h
  }
}

void put_pixel(unsigned int x, unsigned int y, unsigned char color)
{
  asm
  {
      cmp    x,   319
      ja     @1
      cmp    y,   199
      ja     @1
      push   es
      mov    ax,  0A000h
      mov    es,  ax
      xor    dx,  dx
      mov    di,  y
      shl    di,  6
      mov    bx,  y
      shl    bx,  8
      add    di,  bx
      add    di,  x
      mov    al,  color
      stosb
      pop    es
@1:
  }
}

void set_rgb(unsigned char n, unsigned char r, unsigned char g, unsigned char b)
{
  asm
  {
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  r
      shr    al,  2
      out    dx,  al
      mov    al,  g
      shr    al,  2
      out    dx,  al
      mov    al,  b
      shr    al,  2
      out    dx,  al
  }
}

void put_line(int x, int from, int to, unsigned char c1, unsigned char c2)
{
  asm
  {
      mov    ax,  0A000h
      mov    es,  ax
      mov    di,  x
      mov    cx,  200
@1:   mov    al,  c1
      cmp    cx,  from
      jb     @2
      cmp    cx,  to
      ja     @2
      mov    al,  c2
@2:   stosb
      add    di,  319
      loop   @1
  }
}

void load()
{
  FILE *f;
  int i = 0, j = 0;
  char c;

  f = fopen("059-013.bmp", "rb");
  fseek(f, 54, 0);
  fread(pal, 1024, 1, f);
  fread(data, 16384, 1, f);
  fclose(f);

  f = fopen("map.txt", "rt");

  do
  {
    c = getc(f);
    switch (c)
    {
      case '*': map[i][j] = 1; i++; break;
      case ' ': map[i][j] = 0; i++; break;
      case 10: j++; i = 0;
    }
  }
  while (j < 32);

  fclose(f);
}

void set_pal()
{
  for (int i = 1; i < 256; i++)
    set_rgb(i, pal[i * 4 + 2], pal[i * 4 + 1], pal[i * 4]);
}

void main()
{
  char key;
  float xp = 3000, yp = 2048;
  float angle_p = 270, angle, m;
  int color, base_color = 128, d, gm, gd = DETECT;

//  initgraph(&gd, &gm, "c:\\lng\\bc5\\bgi");
  load();
  set_mode(0x13);
  set_pal();
  fill_tables();

/*  setcolor(8);
  for (int i = 0; i < 33; i++)
  {
    line(i * 14, 0, i * 14, 448);
    line(0, i * 14, 448, i * 14);
  }

  setfillstyle(1, 7);
  for (int i = 0; i < 32; i++)
    for (int j = 0; j < 32; j++)
      if (map[i][j])
        bar(i * 14, j * 14, i * 14 + 14, j * 14 + 14);*/

  do
  {
    key = inportb(0x60);
    switch (key)
    {
      case 72: xp -= cos(angle_p * M_PI / 180) * 32; break;
               yp -= sin(angle_p * M_PI / 180) * 32;
      case 80: xp += cos(angle_p * M_PI / 180) * 32; break;
               yp += sin(angle_p * M_PI / 180) * 32;
      case 77: angle_p += 2; break;
      case 75: angle_p -= 2; break;
    }
    if (key >= 2 && key <= 10) base_color = (key - 38) * 16;
    if (angle_p > 359) angle_p = 0;
    if (angle_p < 0) angle_p = 359;
    for (int i = 0; i < 320; i++)
    {
      angle = (angle_p - VIEW_ANGLE / 2) * MUL_CONST + i;
      if (angle > 360 * MUL_CONST) angle -= 360 * MUL_CONST;
      if (angle < 0) angle += 360 * MUL_CONST;
      d = dist(angle, xp, yp);
      if (d)
      {
        m = 30000 / (d * cos((i * ANGLE_CONST - VIEW_ANGLE / 2) * M_PI / 180));
        color = base_color + 16 - (d >> 7);
        if (color < base_color) color = base_color;
      }
      put_line(i, 100 - m / 2, 100 + m / 2, 252, color);
    }
//      getch();
//      closegraph();
//      return;
    K_Reset();
  } while (key != 1);

//  closegraph();
  set_mode(3);
}
